import json
import os,sys

rootdir = '/home/thilod/.cuckoo/storage/analyses/'


#create folder
folder = [('agent',2,868), ('hupigon',868,1175), ('obfuscator',1175,1633), ('onlinegames',1633,2622), ('renos',2622,3608), ('small',3608,4501), ('vb',4501,5574), ('vbinject',5574,6523), ('vundo',6523,7307), ('zlob',7307,8307)] #list of tuples (family_name,start_taskID,end_taskID)

os.system('mkdir ~/Desktop/malwareFamiliesReports/')
for i in range(0,10):
    os.system('mkdir ~/Desktop/malwareFamiliesReports/' + folder[i][0]) #create folder for malware family


for i in range(2,8307):
	#delete errors
	report_dir = rootdir + str(i) + "/reports/report.json"
	summary_exists = False
        error_found = False
	with open(report_dir, 'r') as f:
		data = json.load(f)

	for key, value in dict.items(data["debug"]):
		if key == "errors":
			if len(value) != 0:
				error_found = True
	if error_found == True:
        os.system('rm ' + report_dir)
	    continue
	for key, value in dict.items(data["behavior"]):
		if key == "summary":
			if len(value) != 0:
				summary_exists = True
	if summary_exists == False:
		os.system('rm ' + report_dir)
		continue


	#usage into report.json
	for subdir, dirs, files in os.walk(rootdir + str(i) + "/files/"):
		for file_name in files:
			if file_name[-9:] == "usage.txt": #if file_name.endswidth("usage.txt")
				with open(os.path.join(subdir, file_name), 'r') as uf:
					ram = []
					cpu = []
					for ln in uf:
						if ln.startswith("Memory:"):
							ram.append(float(ln[8:-2]))
						if ln[0].isdigit() == True:
							cpu.append(float(ln[:-1]))
				uf.close()
				if len(ram) == 0 or len(cpu) == 0:
                                    break
				peakCPU = max(cpu)
				peakRAM = max(ram)
				averageCPU = sum(cpu)/len(cpu)
				averageRAM = sum(ram)/len(ram)
				new_dic = {'peakCPU':peakCPU, 'peakRAM':peakRAM, 'averageCPU':averageCPU, 'averageRAM':averageRAM}
				with open(report_dir, 'r+') as rf:
					data = json.load(rf)
					data["behavior"]["summary"].update(new_dic)
				with open(report_dir, 'w') as rf_out:
					json.dump(data, rf_out, indent=4)
				break

	#move to directory
	for x in range (0,10): #start_taskID to end_taskID
		if i >= folder[x][1] and i < folder[x][2]:
        		os.system('cp ' + report_dir + ' ~/Desktop/malwareFamiliesReports/' + folder[x][0] + '/report_' + str(i) + '.json') #copy report to folder
			break



