import json
import os,sys

rootdir = '/home/thilod/Desktop/reports/'

features = []
#features = ['file_created', 'file_recreated', 'regkey_written', 'dll_loaded', 'file_opened', 'file_read', 'regkey_opened', 'file_written', 'regkey_deleted', 'file_deleted', 'file_exists', 'file_failed', 'guid', 'command_line', 'file_moved', 'regkey_read', 'directory_enumerated', 'file_copied', 'resolves_host', 'mutex', 'fetches_url', 'directory_created', 'connects_ip', 'directory_removed', 'connects_host', 'downloads_file', 'wmi_query', 'averageCPU', 'averageRAM', 'peakCPU', 'peakRAM']

for subdir, dirs, files in os.walk(rootdir):
	for file_name in files:
		with open(os.path.join(subdir, file_name), 'r') as f:
			data = json.load(f)

		for key, value in dict.items(data["behavior"]):
			if key == "summary":
				for key, val in dict.items(value):
					if str(key) not in features:
						features.append(str(key))

k = open('/home/thilod/Desktop/malware_classification.json', 'a')
k.write('{"header" : {"relation" : "malware","attributes" : [\n')

for y in features:
	k.write(',{"name" : "'+str(y)+'","type" : "numeric","class" : false,"weight" : 1.0}\n') #attributes
k.write(',{"name" : "family","type" : "nominal","class" : false,"weight" : 1.0,"labels" :["agent","hupigon","obfuscator","onlinegames","renos","small","vb","vbinject","vundo","zlob"]}]},"data" : [\n\n')
				

for subdir, dirs, files in os.walk(rootdir):
	print 'Currently in Folder: ' + os.path.join(subdir)
	for file_name in files:
		k.write(',{"sparse" : false,"weight" : 1.0,"values" : [')
		with open(os.path.join(subdir, file_name), 'r') as f:
			data = json.load(f)

		for key, value in dict.items(data["behavior"]):
			if key == "summary":
				for x in features:
					if x == "averageCPU" or x == "averageRAM" or x == "peakCPU" or x == "peakRAM":
						feature_found = False
						for key, val in dict.items(value):
							if key == x:
								k.write('"' + str(val) + '",')
								feature_found = True
						if feature_found != True:
							k.write('"?",')
					else:
						feature_found = False
						for key, val in dict.items(value):
							if key == x:
								k.write('"' + str(len(val)) + '",')
								feature_found = True
						if feature_found != True:
							k.write('"0",')
		k.write('"' + str(os.path.basename(subdir)) + '"')
		k.write(']}\n')
k.write(']}')
k.close()
