from mlxtend.plotting import plot_confusion_matrix
import matplotlob.pyplot as plt
import numpy as np

multiclass = np.array([
    [390,19,34,9,2,46,57,35,3,5],
    [29,184,26,0,3,3,7,4,3,1],
    [39,33,291,0,3,15,19,16,1,0],
    [15,2,4,886,0,5,6,5,1,4],
    [6,1,3,0,750,1,2,3,8,1],
    [62,6,11,4,1,753,20,9,0,3],
    [25,0,11,4,1,16,787,95,1,0],
    [13,0,6,0,0,3,59,835,2,0],
    [4,1,3,0,7,1,3,2,302,0],
    [5,3,0,5,0,2,5,0,2,954]])

labels = ['agent', 'hupigon', 'obfuscator', 'onlinegames', 'renos', 'small', 'vb', 'vbinject', 'vundo', 'zlob']
fig, ax = plot_confusion_matrix(conf_mat=multiclass, colorbar=True,show_absolute=False,show_normed=True)
plt.ylabel("True label")
plt.xlabel("Predicted label")
tick_marks = np.arrange(len(labels))
plt.xticks(tick_marks,labels,rotation=45)
plt.yticks(tick_marks,labels)

plt.show()
